=== modified file 'src/reference/Makefile.am'
--- src/reference/Makefile.am	2010-08-26 22:34:40 +0000
+++ src/reference/Makefile.am	2010-08-30 23:30:25 +0000
@@ -5,8 +5,6 @@
 	libnewlib.la \
 	libglibc.la
 
-#libbionic.la #libglibc.a libnewlib.a
-
 libbionic_la_SOURCES = \
 	bionic/memcpy.S \
 	bionic/strlen.c
@@ -20,7 +18,14 @@
 	newlib/strcpy.c \
 	newlib/strlen.c
 
+libhelpers_la_SOURCES = \
+	helpers/bounce.c \
+	helpers/spawn.c
+
+libplain_la_SOURCES = \
+	plain/memcpy.c \
+	plain/strcpy.c \
+	plain/strcmp.c
+
 AM_CFLAGS = -std=gnu99
 
-libhelpers_la_SOURCES = helpers/bounce.c helpers/spawn.c
-libplain_la_SOURCES = plain/memcpy.c

=== modified file 'src/reference/bionic/memcmp.S'
--- src/reference/bionic/memcmp.S	2010-08-26 22:19:29 +0000
+++ src/reference/bionic/memcmp.S	2010-08-30 23:30:25 +0000
@@ -26,8 +26,6 @@
  * SUCH DAMAGE.
  */
 
-#include <machine/cpu-features.h>
-
     .text
 
     .global memcmp
@@ -45,8 +43,8 @@
 
 memcmp:
         .fnstart
-        PLD         (r0, #0)
-        PLD         (r1, #0)
+        PLD         [r0, #0]
+        PLD         [r1, #0]
 
         /* take of the case where length is 0 or the buffers are the same */
         cmp         r0, r1
@@ -58,8 +56,8 @@
         /* save registers */
         stmfd       sp!, {r4, lr}
         
-        PLD         (r0, #32)
-        PLD         (r1, #32)
+        PLD         [r0, #32]
+        PLD         [r1, #32]
 
         /* since r0 hold the result, move the first source
          * pointer somewhere else
@@ -109,8 +107,8 @@
         subs        r2, r2, #(32 + 4)
         bmi         1f
         
-0:      PLD         (r4, #64)
-        PLD         (r1, #64)
+0:      PLD         [r4, #64]
+        PLD         [r1, #64]
         ldr         r0, [r4], #4
         ldr         lr, [r1, #4]!
         eors        r0, r0, ip
@@ -198,8 +196,8 @@
         bic         r1, r1, #3
         ldr         lr, [r1], #4
 
-6:      PLD         (r1, #64)
-        PLD         (r4, #64)
+6:      PLD         [r1, #64]
+        PLD         [r4, #64]
         mov         ip, lr, lsr #16
         ldr         lr, [r1], #4
         ldr         r0, [r4], #4

=== modified file 'src/reference/bionic/memcmp16.S'
--- src/reference/bionic/memcmp16.S	2010-08-26 22:19:29 +0000
+++ src/reference/bionic/memcmp16.S	2010-08-30 23:30:25 +0000
@@ -26,8 +26,6 @@
  * SUCH DAMAGE.
  */
 
-#include <machine/cpu-features.h>
-
     .text
 
     .global __memcmp16
@@ -45,8 +43,8 @@
 
 __memcmp16:
         .fnstart
-        PLD         (r0, #0)
-        PLD         (r1, #0)
+        PLD         [r0, #0]
+        PLD         [r1, #0]
 
         /* take of the case where length is nul or the buffers are the same */
         cmp         r0, r1
@@ -68,8 +66,8 @@
         bpl         0f
 
         /* small blocks (less then 12 words) */
-        PLD         (r0, #32)
-        PLD         (r1, #32)
+        PLD         [r0, #32]
+        PLD         [r1, #32]
 
 1:      ldrh        r0, [r3], #2
         ldrh        ip, [r1], #2
@@ -119,8 +117,8 @@
         bmi         1f
         
 0:
-        PLD         (r3, #64)
-        PLD         (r1, #64)
+        PLD         [r3, #64]
+        PLD         [r1, #64]
         ldr         r0, [r3], #4
         ldr         lr, [r1, #4]!
         eors        r0, r0, ip
@@ -201,8 +199,8 @@
         sub         r2, r2, #8
 
 6:
-        PLD         (r3, #64)
-        PLD         (r1, #64)
+        PLD         [r3, #64]
+        PLD         [r1, #64]
         mov         ip, lr, lsr #16
         ldr         lr, [r1], #4
         ldr         r0, [r3], #4

=== modified file 'src/reference/bionic/memcpy.S'
--- src/reference/bionic/memcpy.S	2010-08-26 22:34:40 +0000
+++ src/reference/bionic/memcpy.S	2010-08-30 23:30:25 +0000
@@ -26,8 +26,6 @@
  * SUCH DAMAGE.
  */
 
-#define __ARM_NEON__
-
 #if defined(__ARM_NEON__)
         .text
         .fpu    neon

=== added directory 'src/reference/csl'
=== added file 'src/reference/csl/arm_asm.h'
--- src/reference/csl/arm_asm.h	1970-01-01 00:00:00 +0000
+++ src/reference/csl/arm_asm.h	2010-08-30 23:30:25 +0000
@@ -0,0 +1,82 @@
+/*
+ * Copyright (c) 2009 ARM Ltd
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. The name of the company may not be used to endorse or promote
+ *    products derived from this software without specific prior written
+ *    permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY ARM LTD ``AS IS'' AND ANY EXPRESS OR IMPLIED
+ * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL ARM LTD BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
+ * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
+ * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
+ * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
+ * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef ARM_ASM__H
+#define ARM_ASM__H
+
+/* First define some macros that keep everything else sane.  */
+#if defined (__ARM_ARCH_7A__) || defined (__ARM_ARCH_7R__)
+#define _ISA_ARM_7
+#endif
+
+#if defined (_ISA_ARM_7) || defined (__ARM_ARCH_6__) || \
+    defined (__ARM_ARCH_6J__) || defined (__ARM_ARCH_6T2__) || \
+    defined (__ARM_ARCH_6K__) || defined (__ARM_ARCH_6ZK__) || \
+    defined (__ARM_ARCH_6Z__)
+#define _ISA_ARM_6
+#endif
+
+#if defined (_ISA_ARM_6) || defined (__ARM_ARCH_5__) || \
+    defined (__ARM_ARCH_5T__) || defined (__ARM_ARCH_5TE__) || \
+    defined (__ARM_ARCH_5TEJ__)
+#define _ISA_ARM_5
+#endif
+
+#if defined (_ISA_ARM_5) || defined (__ARM_ARCH_4T__)
+#define _ISA_ARM_4T
+#endif
+
+#if defined (__ARM_ARCH_7M__) || defined (__ARM_ARCH_7__) || \
+    defined (__ARM_ARCH_7EM__)
+#define _ISA_THUMB_2
+#endif
+
+#if defined (_ISA_THUMB_2) || defined (__ARM_ARCH_6M__)
+#define _ISA_THUMB_1
+#endif
+
+
+/* Now some macros for common instruction sequences.  */
+
+asm(".macro  RETURN	cond=\n\t"
+#if defined (_ISA_ARM_4T) || defined (_ISA_THUMB_1)
+    "bx\\cond	lr\n\t"
+#else
+    "mov\\cond	pc, lr\n\t"
+#endif
+    ".endm"
+    );
+
+asm(".macro optpld	base, offset=#0\n\t"
+#if defined (_ISA_ARM_7)
+    "pld	[\\base, \\offset]\n\t"
+#endif
+    ".endm"
+    );
+
+#endif /* ARM_ASM__H */

=== added file 'src/reference/csl/memcpy.c'
--- src/reference/csl/memcpy.c	1970-01-01 00:00:00 +0000
+++ src/reference/csl/memcpy.c	2010-08-30 23:30:25 +0000
@@ -0,0 +1,291 @@
+/* Copyright (c) 2009 CodeSourcery, Inc.
+ * All rights reserved.
+ * 
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *     * Redistributions of source code must retain the above copyright
+ *       notice, this list of conditions and the following disclaimer.
+ *     * Redistributions in binary form must reproduce the above copyright
+ *       notice, this list of conditions and the following disclaimer in the
+ *       documentation and/or other materials provided with the distribution.
+ *     * Neither the name of CodeSourcery nor the
+ *       names of its contributors may be used to endorse or promote products
+ *       derived from this software without specific prior written permission.
+ * 
+ * THIS SOFTWARE IS PROVIDED BY CODESOURCERY, INC. ``AS IS'' AND ANY
+ * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ * DISCLAIMED. IN NO EVENT SHALL CODESOURCERY BE LIABLE FOR ANY
+ * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include "arm_asm.h"
+#include <string.h>
+#include <stdint.h>
+#include <stddef.h>
+
+/* Standard operations for word-sized values.  */
+#define WORD_REF(ADDRESS, OFFSET) \
+	*((WORD_TYPE*)((char*)(ADDRESS) + (OFFSET)))
+#define WORD_COPY(OUT, IN, OFFSET) \
+	WORD_REF(OUT, OFFSET) = WORD_REF(IN, OFFSET)
+
+/* On processors with NEON, we use 128-bit vectors.  Also,
+   we need to include arm_neon.h to use these.  */
+#if defined(__ARM_NEON__)
+  #include <arm_neon.h>
+
+  #define WORD_TYPE uint8x16_t
+  #define WORD_SIZE 16
+  #define MAYBE_PREFETCH(IN) __builtin_prefetch((IN), 0, 0)
+
+/* On ARM processors with 64-bit ldrd instructions, we use those,
+   except on Cortex-M* where benchmarking has shown them to
+   be slower.  */
+#elif defined(__ARM_ARCH_5E__) || defined(__ARM_ARCH_5TE__) \
+	|| defined(__ARM_ARCH_5TEJ__) || defined(_ISA_ARM_6)
+  #define WORD_TYPE uint64_t
+  #define WORD_SIZE 8
+  #define MAYBE_PREFETCH(IN) __builtin_prefetch((IN), 0, 0)
+
+/* On everything else, we use 32-bit loads and stores, and
+   do not use prefetching.  */
+#else
+  #define WORD_TYPE uint32_t
+  #define WORD_SIZE 4
+  #define MAYBE_PREFETCH(IN)
+#endif
+
+/* On all ARM platforms, 'SHORTWORD' is a 32-bit value.  */
+#define SHORTWORD_TYPE uint32_t
+#define SHORTWORD_SIZE 4
+#define SHORTWORD_REF(ADDRESS, OFFSET) \
+	*((SHORTWORD_TYPE*)((char*)(ADDRESS) + (OFFSET)))
+#define SHORTWORD_COPY(OUT, IN, OFFSET) \
+	SHORTWORD_REF(OUT, OFFSET) = SHORTWORD_REF(IN, OFFSET)
+
+/* Shifting directionality depends on endianness.  */
+#ifdef __ARMEB__
+#define SHORTWORD_SHIFT(IN0, IN1, OFFSET) \
+	((IN0) << ((OFFSET)*8)) | ((IN1) >> (SHORTWORD_SIZE*8 - (OFFSET)*8))
+#else
+#define SHORTWORD_SHIFT(IN0, IN1, OFFSET) \
+	((IN0) >> ((OFFSET)*8)) | ((IN1) << (SHORTWORD_SIZE*8 - (OFFSET)*8))
+#endif
+
+void *memcpy(void *OUT, const void *IN, size_t N)
+{
+  void* OUT0 = OUT;
+
+#if defined(PREFER_SIZE_OVER_SPEED) || defined(__OPTIMIZE_SIZE__)
+  const char* OUT_end = (char*)OUT + N;
+  while ((char*)OUT < OUT_end) {
+    *((char*)OUT) = *((char*)IN);
+    OUT++;
+    IN++;
+  }
+
+  return OUT0;
+#else
+  /* Handle short strings and immediately return.  */
+  if (__builtin_expect(N < SHORTWORD_SIZE, 1)) {
+    size_t i = 0;
+    while (i < N) {
+      ((char*)OUT)[i] = ((char*)IN)[i];
+      i++;
+    }
+    return OUT;
+  }
+
+  const char* OUT_end = (char*)OUT + N;
+
+  /* Align OUT to SHORTWORD_SIZE.  */
+  while ((uintptr_t)OUT % SHORTWORD_SIZE != 0) {
+    *(char*) (OUT++) = *(char*) (IN++);
+  }
+
+  if ((uintptr_t) IN % SHORTWORD_SIZE == 0) {
+
+#if WORD_SIZE > SHORTWORD_SIZE
+    /* Align OUT to WORD_SIZE in steps of SHORTWORD_SIZE.  */
+    if (__builtin_expect(OUT_end - (char*)OUT >= WORD_SIZE, 0)) {
+      while ((uintptr_t)OUT % WORD_SIZE != 0) {
+        SHORTWORD_COPY(OUT, IN, 0);
+        OUT += SHORTWORD_SIZE;
+        IN += SHORTWORD_SIZE;
+      }
+
+      if ((uintptr_t) IN % WORD_SIZE == 0) {
+#endif /* WORD_SIZE > SHORTWORD_SIZE */
+
+#if defined(__ARM_NEON__)
+        /* Testing on Cortex-A8 indicates that the following idiom
+           produces faster assembly code when doing vector copies,
+           but not when doing regular copies.  */
+        size_t i = 0;
+        N = OUT_end - (char*)OUT;
+        MAYBE_PREFETCH(IN + 64);
+        MAYBE_PREFETCH(IN + 128);
+        MAYBE_PREFETCH(IN + 192);
+        if (N >= 640) {
+          MAYBE_PREFETCH(IN + 256);
+          MAYBE_PREFETCH(IN + 320);
+          MAYBE_PREFETCH(IN + 384);
+          MAYBE_PREFETCH(IN + 448);
+          MAYBE_PREFETCH(IN + 512);
+          MAYBE_PREFETCH(IN + 576);
+          MAYBE_PREFETCH(IN + 640);
+          MAYBE_PREFETCH(IN + 704);
+	  /* We phrase the loop condition in this way so that the
+             i + WORD_SIZE * 16 value can be reused to increment i.  */
+          while (i + WORD_SIZE * 16 <= N - 640) {
+            MAYBE_PREFETCH(IN + 768);
+            MAYBE_PREFETCH(IN + 832);
+            MAYBE_PREFETCH(IN + 896);
+            MAYBE_PREFETCH(IN + 960);
+            WORD_COPY(OUT, IN, i);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 1);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 2);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 3);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 4);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 5);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 6);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 7);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 8);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 9);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 10);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 11);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 12);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 13);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 14);
+            WORD_COPY(OUT, IN, i + WORD_SIZE * 15);
+            i += WORD_SIZE * 16;
+          }
+        }
+        while (i + WORD_SIZE * 16 <= N) {
+          WORD_COPY(OUT, IN, i);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 1);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 2);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 3);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 4);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 5);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 6);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 7);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 8);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 9);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 10);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 11);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 12);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 13);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 14);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 15);
+          i += WORD_SIZE * 16;
+        }
+        while (i + WORD_SIZE * 4 <= N) {
+          WORD_COPY(OUT, IN, i);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 1);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 2);
+          WORD_COPY(OUT, IN, i + WORD_SIZE * 3);
+          i += WORD_SIZE * 4;
+        }
+        while (i + WORD_SIZE <= N) {
+          WORD_COPY(OUT, IN, i);
+          i += WORD_SIZE;
+        }
+        OUT += i;
+        IN += i;
+#else /* not defined(__ARM_NEON__) */
+        /* Note: 16-times unrolling is about 20% faster than 4-times
+           unrolling on both ARM Cortex-A8 and Cortex-M3.  */
+        MAYBE_PREFETCH(IN + 64);
+        MAYBE_PREFETCH(IN + 128);
+        MAYBE_PREFETCH(IN + 192);
+        while (OUT_end - (char*)OUT >= WORD_SIZE * 16) {
+          MAYBE_PREFETCH(IN + 256);
+          MAYBE_PREFETCH(IN + 320);
+          WORD_COPY(OUT, IN, 0);
+          WORD_COPY(OUT, IN, WORD_SIZE * 1);
+          WORD_COPY(OUT, IN, WORD_SIZE * 2);
+          WORD_COPY(OUT, IN, WORD_SIZE * 3);
+          WORD_COPY(OUT, IN, WORD_SIZE * 4);
+          WORD_COPY(OUT, IN, WORD_SIZE * 5);
+          WORD_COPY(OUT, IN, WORD_SIZE * 6);
+          WORD_COPY(OUT, IN, WORD_SIZE * 7);
+          WORD_COPY(OUT, IN, WORD_SIZE * 8);
+          WORD_COPY(OUT, IN, WORD_SIZE * 9);
+          WORD_COPY(OUT, IN, WORD_SIZE * 10);
+          WORD_COPY(OUT, IN, WORD_SIZE * 11);
+          WORD_COPY(OUT, IN, WORD_SIZE * 12);
+          WORD_COPY(OUT, IN, WORD_SIZE * 13);
+          WORD_COPY(OUT, IN, WORD_SIZE * 14);
+          WORD_COPY(OUT, IN, WORD_SIZE * 15);
+          OUT += WORD_SIZE * 16;
+          IN += WORD_SIZE * 16;
+        }
+        while (WORD_SIZE * 4 <= OUT_end - (char*)OUT) {
+          WORD_COPY(OUT, IN, 0);
+          WORD_COPY(OUT, IN, WORD_SIZE * 1);
+          WORD_COPY(OUT, IN, WORD_SIZE * 2);
+          WORD_COPY(OUT, IN, WORD_SIZE * 3);
+          OUT += WORD_SIZE * 4;
+          IN += WORD_SIZE * 4;
+        }
+        while (WORD_SIZE <= OUT_end - (char*)OUT) {
+          WORD_COPY(OUT, IN, 0);
+          OUT += WORD_SIZE;
+          IN += WORD_SIZE;
+        }
+#endif /* not defined(__ARM_NEON__) */
+
+#if WORD_SIZE > SHORTWORD_SIZE
+      } else { /* if IN is not WORD_SIZE aligned */
+        while (SHORTWORD_SIZE * 4 <= OUT_end - (char*)OUT) {
+          SHORTWORD_COPY(OUT, IN, 0);
+          SHORTWORD_COPY(OUT, IN, SHORTWORD_SIZE * 1);
+          SHORTWORD_COPY(OUT, IN, SHORTWORD_SIZE * 2);
+          SHORTWORD_COPY(OUT, IN, SHORTWORD_SIZE * 3);
+          OUT += SHORTWORD_SIZE * 4;
+          IN += SHORTWORD_SIZE * 4;
+        }
+      } /* end if IN is not WORD_SIZE aligned */
+    } /* end if N >= WORD_SIZE */
+
+    while (SHORTWORD_SIZE <= OUT_end - (char*)OUT) {
+      SHORTWORD_COPY(OUT, IN, 0);
+      OUT += SHORTWORD_SIZE;
+      IN += SHORTWORD_SIZE;
+    }
+#endif /* WORD_SIZE > SHORTWORD_SIZE */
+
+  } else { /* if IN is not SHORTWORD_SIZE aligned */
+    ptrdiff_t misalign = (uintptr_t)IN % SHORTWORD_SIZE;
+
+    SHORTWORD_TYPE temp1, temp2;
+    temp1 = SHORTWORD_REF(IN, -misalign);
+
+    /* Benchmarking indicates that unrolling this loop doesn't
+       produce a measurable performance improvement on ARM.  */
+    while (SHORTWORD_SIZE <= OUT_end - (char*)OUT) {
+      IN += SHORTWORD_SIZE;
+      temp2 = SHORTWORD_REF(IN, -misalign);
+      SHORTWORD_REF(OUT, 0) = SHORTWORD_SHIFT(temp1, temp2, misalign);
+      temp1 = temp2;
+      OUT += SHORTWORD_SIZE;
+    }
+
+  } /* end if IN is not SHORTWORD_SIZE aligned */
+
+  while ((char*)OUT < OUT_end) {
+    *((char*)OUT) = *((char*)IN);
+    OUT++;
+    IN++;
+  }
+
+  return OUT0;
+#endif
+}

=== added file 'src/reference/csl/memset.c'
--- src/reference/csl/memset.c	1970-01-01 00:00:00 +0000
+++ src/reference/csl/memset.c	2010-08-30 23:30:25 +0000
@@ -0,0 +1,214 @@
+/* Copyright (c) 2009 CodeSourcery, Inc.
+ * All rights reserved.
+ * 
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are met:
+ *     * Redistributions of source code must retain the above copyright
+ *       notice, this list of conditions and the following disclaimer.
+ *     * Redistributions in binary form must reproduce the above copyright
+ *       notice, this list of conditions and the following disclaimer in the
+ *       documentation and/or other materials provided with the distribution.
+ *     * Neither the name of CodeSourcery nor the
+ *       names of its contributors may be used to endorse or promote products
+ *       derived from this software without specific prior written permission.
+ * 
+ * THIS SOFTWARE IS PROVIDED BY CODESOURCERY, INC. ``AS IS'' AND ANY
+ * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ * DISCLAIMED. IN NO EVENT SHALL CODESOURCERY BE LIABLE FOR ANY
+ * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
+ * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+ * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
+ * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#include "arm_asm.h"
+#include <string.h>
+#include <stdint.h>
+
+/* Standard operations for word-sized values.  */
+#define WORD_REF(ADDRESS, OFFSET) \
+	*((WORD_TYPE*)((char*)(ADDRESS) + (OFFSET)))
+
+/* On processors with NEON, we use 128-bit vectors.  Also,
+   we need to include arm_neon.h to use these.  */
+#if defined(__ARM_NEON__)
+  #include <arm_neon.h>
+
+  #define WORD_TYPE uint8x16_t
+  #define WORD_SIZE 16
+
+  #define WORD_DUPLICATE(VALUE) \
+	vdupq_n_u8(VALUE)
+
+/* On ARM processors with 64-bit ldrd instructions, we use those,
+   except on Cortex-M* where benchmarking has shown them to
+   be slower.  */
+#elif defined(__ARM_ARCH_5E__) || defined(__ARM_ARCH_5TE__) \
+	|| defined(__ARM_ARCH_5TEJ__) || defined(_ISA_ARM_6)
+  #define WORD_TYPE uint64_t
+  #define WORD_SIZE 8
+
+  /* ARM stores 64-bit values in two 32-bit registers and does not
+     have 64-bit multiply or bitwise-or instructions, so this union
+     operation results in optimal code.  */
+  static inline uint64_t splat8(value) {
+	union { uint32_t ints[2]; uint64_t result; } quad;
+	quad.ints[0] = (unsigned char)(value) * 0x01010101;
+	quad.ints[1] = quad.ints[0];
+	return quad.result;
+  }
+  #define WORD_DUPLICATE(VALUE) \
+	splat8(VALUE)
+
+/* On everything else, we use 32-bit loads and stores.  */
+#else
+  #define WORD_TYPE uint32_t
+  #define WORD_SIZE 4
+  #define WORD_DUPLICATE(VALUE) \
+	(unsigned char)(VALUE) * 0x01010101
+#endif
+
+/* On all ARM platforms, 'SHORTWORD' is a 32-bit value.  */
+#define SHORTWORD_TYPE uint32_t
+#define SHORTWORD_SIZE 4
+#define SHORTWORD_REF(ADDRESS, OFFSET) \
+	*((SHORTWORD_TYPE*)((char*)(ADDRESS) + (OFFSET)))
+#define SHORTWORD_DUPLICATE(VALUE) \
+	(uint32_t)(unsigned char)(VALUE) * 0x01010101
+
+void *memset(void *DST, int C, size_t LENGTH)
+{
+  void* DST0 = DST;
+  unsigned char C_BYTE = C;
+
+#if defined(PREFER_SIZE_OVER_SPEED) || defined(__OPTIMIZE_SIZE__)
+  const char* DST_end = (char*)DST + LENGTH;
+  while ((char*)DST < DST_end) {
+    *((char*)DST) = C_BYTE;
+    DST++;
+  }
+
+  return DST0;
+#else /* not PREFER_SIZE_OVER_SPEED */
+  /* Handle short strings and immediately return.  */
+  if (__builtin_expect(LENGTH < SHORTWORD_SIZE, 1)) {
+    size_t i = 0;
+    while (i < LENGTH) {
+      ((char*)DST)[i] = C_BYTE;
+      i++;
+    }
+    return DST;
+  }
+
+  const char* DST_end = (char*)DST + LENGTH;
+
+  /* Align DST to SHORTWORD_SIZE.  */
+  while ((uintptr_t)DST % SHORTWORD_SIZE != 0) {
+    *(char*) (DST++) = C_BYTE;
+  }
+
+#if WORD_SIZE > SHORTWORD_SIZE
+  SHORTWORD_TYPE C_SHORTWORD = SHORTWORD_DUPLICATE(C_BYTE);
+
+  /* Align DST to WORD_SIZE in steps of SHORTWORD_SIZE.  */
+  if (__builtin_expect(DST_end - (char*)DST >= WORD_SIZE, 0)) {
+    while ((uintptr_t)DST % WORD_SIZE != 0) {
+      SHORTWORD_REF(DST, 0) = C_SHORTWORD;
+      DST += SHORTWORD_SIZE;
+    }
+#endif /* WORD_SIZE > SHORTWORD_SIZE */
+
+    WORD_TYPE C_WORD = WORD_DUPLICATE(C_BYTE);
+
+#if defined(__ARM_NEON__)
+    /* Testing on Cortex-A8 indicates that the following idiom
+       produces faster assembly code when doing vector copies,
+       but not when doing regular copies.  */
+    size_t i = 0;
+    LENGTH = DST_end - (char*)DST;
+    while (i + WORD_SIZE * 16 <= LENGTH) {
+      WORD_REF(DST, i) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 1) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 2) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 3) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 4) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 5) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 6) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 7) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 8) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 9) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 10) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 11) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 12) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 13) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 14) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 15) = C_WORD;
+      i += WORD_SIZE * 16;
+    }
+    while (i + WORD_SIZE * 4 <= LENGTH) {
+      WORD_REF(DST, i) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 1) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 2) = C_WORD;
+      WORD_REF(DST, i + WORD_SIZE * 3) = C_WORD;
+      i += WORD_SIZE * 4;
+    }
+    while (i + WORD_SIZE <= LENGTH) {
+      WORD_REF(DST, i) = C_WORD;
+      i += WORD_SIZE;
+    }
+    DST += i;
+#else /* not defined(__ARM_NEON__) */
+    /* Note: 16-times unrolling is about 50% faster than 4-times
+       unrolling on both ARM Cortex-A8 and Cortex-M3.  */
+    while (DST_end - (char*) DST >= WORD_SIZE * 16) {
+      WORD_REF(DST, 0) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 1) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 2) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 3) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 4) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 5) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 6) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 7) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 8) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 9) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 10) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 11) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 12) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 13) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 14) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 15) = C_WORD;
+      DST += WORD_SIZE * 16;
+    }
+    while (WORD_SIZE * 4 <= DST_end - (char*) DST) {
+      WORD_REF(DST, 0) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 1) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 2) = C_WORD;
+      WORD_REF(DST, WORD_SIZE * 3) = C_WORD;
+      DST += WORD_SIZE * 4;
+    }
+    while (WORD_SIZE <= DST_end - (char*) DST) {
+      WORD_REF(DST, 0) = C_WORD;
+      DST += WORD_SIZE;
+    }
+#endif /* not defined(__ARM_NEON__) */
+
+#if WORD_SIZE > SHORTWORD_SIZE
+  } /* end if N >= WORD_SIZE */
+
+  while (SHORTWORD_SIZE <= DST_end - (char*)DST) {
+    SHORTWORD_REF(DST, 0) = C_SHORTWORD;
+    DST += SHORTWORD_SIZE;
+  }
+#endif /* WORD_SIZE > SHORTWORD_SIZE */
+
+  while ((char*)DST < DST_end) {
+    *((char*)DST) = C_BYTE;
+    DST++;
+  }
+
+  return DST0;
+#endif /* not PREFER_SIZE_OVER_SPEED */
+}

=== modified file 'src/reference/glibc/memmove.S'
--- src/reference/glibc/memmove.S	2010-08-26 22:19:29 +0000
+++ src/reference/glibc/memmove.S	2010-08-30 23:30:25 +0000
@@ -18,8 +18,6 @@
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA.  */
 
-#include <sysdep.h>
-
 /*
  * Data preload for architectures that support it (ARM V5TE and above)
  */
@@ -62,15 +60,10 @@
  * normally a bit faster. Otherwise the copy is done going downwards.
  */
 
-ENTRY(memmove)
-
+memmove:
 		subs	ip, r0, r1
 		cmphi	r2, ip
-#ifdef NOT_IN_libc
 		bls	memcpy
-#else
-		bls	HIDDEN_JUMPTARGET(memcpy)
-#endif
 
 		stmfd	sp!, {r0, r4, lr}
 		add	r1, r1, r2
@@ -240,7 +233,3 @@
 17:		backward_copy_shift	push=16	pull=16
 
 18:		backward_copy_shift	push=24	pull=8
-
-
-END(memmove)
-libc_hidden_builtin_def (memmove)

=== modified file 'src/reference/glibc/memset.S'
--- src/reference/glibc/memset.S	2010-08-26 22:19:29 +0000
+++ src/reference/glibc/memset.S	2010-08-30 23:30:25 +0000
@@ -17,11 +17,9 @@
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA.  */
 
-#include <sysdep.h>
-
 /* void *memset (dstpp, c, len) */
 
-ENTRY(memset)
+memset:	
 	mov	r3, r0
 	cmp	r2, #8
 	bcc	2f		@ less than 8 bytes to move
@@ -60,6 +58,4 @@
 	strcsb	r1, [r3], #1
 	bcs	2b
 	
-	DO_RET(lr)
-END(memset)
-libc_hidden_builtin_def (memset)
+	bx	lr

=== added file 'src/reference/plain/memset.c'
--- src/reference/plain/memset.c	1970-01-01 00:00:00 +0000
+++ src/reference/plain/memset.c	2010-08-30 23:30:25 +0000
@@ -0,0 +1,15 @@
+#include <stddef.h>
+
+void *memset(void *dst0, int c, size_t len0)
+{
+  char *dst = (char *) dst0;
+
+  void *save = dst0;
+
+  while (len0--)
+    {
+      *dst++ = c;
+    }
+
+  return save;
+}

=== added file 'src/reference/plain/strcmp.c'
--- src/reference/plain/strcmp.c	1970-01-01 00:00:00 +0000
+++ src/reference/plain/strcmp.c	2010-08-30 23:30:25 +0000
@@ -0,0 +1,11 @@
+int strcmp(const char *s1, const char *s2)
+{ 
+  while (*s1 != '\0' && *s1 == *s2)
+    {
+      s1++;
+      s2++;
+    }
+
+  return (*(unsigned char *) s1) - (*(unsigned char *) s2);
+}
+

=== added file 'src/reference/plain/strcpy.c'
--- src/reference/plain/strcpy.c	1970-01-01 00:00:00 +0000
+++ src/reference/plain/strcpy.c	2010-08-30 23:30:25 +0000
@@ -0,0 +1,9 @@
+char* strcpy(char *dst0, const char *src0)
+{
+  char *s = dst0;
+
+  while (*dst0++ = *src0++)
+    ;
+
+  return s;
+}

